﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinFormsFallingRock {
	public partial class Form1 : Form {
		List<Rock> rocks = new List<Rock>();
		DateTime lastTick;

		public Form1() {
			InitializeComponent();

			SetStyle(ControlStyles.ResizeRedraw, true);

			SetStyle(ControlStyles.AllPaintingInWmPaint
				| ControlStyles.OptimizedDoubleBuffer | ControlStyles.UserPaint, true);

			rocks.Add(new Rock { Location = new Point(100, 0), Size = new Size(20, 20), Speed = 100 });
			rocks.Add(new Rock { Location = new Point(200, 0), Size = new Size(20, 20), Speed = 50 });
			rocks.Add(new Rock { Location = new Point(300, 0), Size = new Size(20, 20), Speed = 300 });

			lastTick = DateTime.Now;
		}

		private void timer1_Tick(object sender, EventArgs e) {
			// Update
			var now = DateTime.Now;
			foreach (Rock r in rocks) {
				r.Location.Y += (int) ((now - lastTick).TotalSeconds * r.Speed);
			}
			lastTick = now;

			// Draw
			Refresh();
		}

		protected override void OnPaint(PaintEventArgs e) {
			Graphics g = e.Graphics;

			foreach (Rock r in rocks) {
				g.FillEllipse(Brushes.Brown,
					r.Location.X - r.Size.Width / 2,
					r.Location.Y - r.Size.Height / 2,
					r.Size.Width, r.Size.Height
				);
			}
		}
	}

	class Rock {
		public Point Location;
		public Size Size;
		public double Speed;
	}
}
